/* 
   manae --- skimple kana MANA Exchanger
   completion.c --- manae's completion conversion module
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _COMPLETION_C_
#define _COMPLETION_C_

#include <PalmOS.h>

#include "id.h"
#include "manae.h"
#include "myfunc.h"

Int addChar(CharPtr str, Char c);
CharPtr GetNextChar(CharPtr source, Char sep, Char stopC);
CharPtr searchStr(CharPtr target, CharPtr domain, ULong len,
		  Char sep, Char stopC);
VoidHand ManaeGetCandRec(GlobalPtr g);
Err ManaeReleaseCandRec(GlobalPtr g);
VoidHand ManaeGetUserCandRec(GlobalPtr g);
Err ManaeReleaseUserCandRec(GlobalPtr g);
VoidHand ManaeGetLearnCandRec(GlobalPtr g);
Err ManaeReleaseLearnCandRec(GlobalPtr g);
Boolean ManaeCandInit(GlobalPtr g);
CharPtr mystrncpy(CharPtr d, const Char* s, Word n);
CharPtr strncpyplus(CharPtr dist, CharPtr source, Int len, Char sep);
CharPtr CandsSkipCand(CharPtr ptr, Int columnNum);
Boolean CandsSetCand(CharPtr distP, CharPtr srcP, DWord page, Int i);
Int DeleteAChar(CharPtr str);
Boolean  Kana2Consonant(CharPtr okuriC, CharPtr tmpStr);
Int CandsShotenKana(CharPtr kana, CharPtr okuriC, CharPtr okuri);
Boolean CandsDicCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
			  GlobalPtr g);
Boolean CandsUserCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
			  GlobalPtr g);
Boolean CandsCandInit(CharPtr kana, Char okuriC, CharPtr okuri,
		      GlobalPtr g);
CharPtr CandsGetCandP(CharPtr target, GlobalPtr g);
ULong CandsWriteCandsList(CharPtr dist, ULongPtr distOffset, 
			  CharPtr srcBase, Int srcOffset,
			  CharPtr kana, CharPtr okuri);

DmOpenRef OpenMemoDB(GlobalPtr g);
Err CloseMemoDB(GlobalPtr g);
int BM1(unsigned char *pat, int patLen, unsigned char *text,
	unsigned long orgTextLen);
CharPtr searchLearnYomiCompl(CharPtr yomiP, VoidPtr learnP,
			     VoidPtr boundaryP);


Boolean show(CharPtr s1, CharPtr s2, CharPtr s3)
{
  Char tmpP[32];
  mystrncpy(tmpP, s3, 28);
  FrmCustomAlert(Alert, s1, s2, tmpP);
  return(true);
}

Int getNextLine(CharPtr domain, Int len)
{
  Int i;

  for (i = 0; ((domain[i] != crChr) && (domain[i] != linefeedChr)); i++) {
    if (i >= len) return(-1);
  }
  return(i);
}


Boolean subMatch(CharPtr srcP, CharPtr domainP)
{
  Int i;

  for (i = 0; srcP[i] != nullChr; i++) {
    if (srcP[i] != domainP[i]) return(false);
  }
  return(true);
}

CharPtr halfMatch(CharPtr target, CharPtr domain, Int len,
		  Char sep)
{
  Int i,j ;


  for (i = 0; i < len; i++) {
    if (subMatch(target, domain + i)) {
        return(domain + i);
    } else {
      if ((j = getNextLine(domain + i, len - i)) == -1) return(NULL);
      i = i + j;
    }
  }
  return(NULL);
}

ULong ComplWriteCandList(CharPtr distP, ULongPtr distOffset, 
			  CharPtr srcP, Int srcOffset,
			  CharPtr kana)
{
  Char tmp[1];

  tmp[0] = nullChr;

  return(CandsWriteCandsList(distP, distOffset, srcP, srcOffset, kana, tmp));
}

Boolean ComplGetNextMatch(CharPtr srcP, IntPtr srcOffset, Int len,
			  Char stopC, CharPtr kana)
{
  CharPtr currP;

  if ((*srcOffset >= len) || (srcP == NULL)) {
    return(false);
  }
  
  // for null yomigana.
  if (*kana == nullChr) {
    if (*srcOffset == 0) {
      return(true);
    }
    for (;*srcOffset < len; (*srcOffset)++) {
      if ((*(srcP + *srcOffset) == crChr) ||
	  (*(srcP + *srcOffset) == linefeedChr)) {
	(*srcOffset)++;
	return(true);
      }
    }
    return(false);
  }
	  
  // 
  currP = srcP + *srcOffset;
   
  do {
    if ((currP = halfMatch(kana, srcP + *srcOffset,
			   (len - *srcOffset),
		       '/')) == NULL) {
      return(false);
    }
  } while(currP[1] == '/');
  *srcOffset = currP - srcP;

  return(true);
}

Boolean ComplMakeCandList(CharPtr distP, ULongPtr distOffset, 
		       CharPtr kana, GlobalPtr g)
{
  CharPtr srcP;
  Char tmpKanaP[KANALEN + 4];
  Int srcOffset;
    
  srcOffset = 0;

  if (OpenMemoDB(g)) {
    if (ManaeGetLearnCandRec(g)) {
      CharPtr tP;
      tP = g->learnDicP + g->learnDicStartPoint;
      //      WinDrawChars(tP, 30, 0, 140);
      do {
	if ((tP = searchLearnYomiCompl(kana, (VoidPtr)tP,
				       g->learnDicP + g->learnDicLen - 1))
	    == NULL) break;
	//	WinDrawChars(tP + 1, 18, 0, 150);
	for (srcP = tP + 1; *srcP != '/';
	     srcP += (*(unsigned char*)srcP > 0x80) ? 2 : 1);
	//	srcP++;  srcP's head must be '/' 
	//	WinDrawChars(srcP, 18, 100, 150);
	srcOffset = srcP - g->learnDicP;
	ComplWriteCandList(distP, distOffset, g->learnDicP, srcOffset, kana);
	for(tP = srcP;
	    ((*tP != linefeedChr) &&
	     (tP < (g->learnDicP + g->learnDicLen - 1))); tP++);
	for(;((*tP == linefeedChr) &&
	      (tP < (g->learnDicP + g->learnDicLen - 1))); tP++);
      } while (*distOffset < CANDSCOMPLSIZE);
      ManaeReleaseLearnCandRec(g);
    }
    CloseMemoDB(g);
  }
  
  if (ManaeGetUserCandRec(g)) {
    do {
      if (!ComplGetNextMatch(g->userDicP, &srcOffset, (Int)g->userDicLen, 
			     linefeedChr, kana)) break;
      srcP = GetNextChar(g->userDicP + srcOffset, '/', linefeedChr);
      srcOffset = srcP - g->userDicP;
      ComplWriteCandList(distP, distOffset, g->userDicP, srcOffset, kana);

    } while (*distOffset < CANDSCOMPLSIZE);
    ManaeReleaseUserCandRec(g);
  }

  DmSet(distP, *distOffset, 2, nullChr);

  srcOffset = 0;
  tmpKanaP[0] = nullChr;
  StrCat(tmpKanaP, kana + 2);
  //  if (tmpKanaP[0] == nullChr) return(*distOffset > 0);

  if(ManaeGetCandRec(g)) {
    do {
      if (!ComplGetNextMatch(g->candP, &srcOffset, g->candRecLen, 
			     crChr, tmpKanaP)) break;
      if ((srcP = GetNextChar(g->candP + srcOffset, '/', crChr)) 
	  == NULL) return(false);
      srcOffset = srcP - g->candP;
      ComplWriteCandList(distP, distOffset, g->candP, srcOffset, kana);
    } while (*distOffset < CANDSCOMPLSIZE);
    ManaeReleaseCandRec(g);
  }
  DmSet(distP, *distOffset, 2, nullChr);
  return(*distOffset > 0);
}

// Now this function searches in J-OS dic only.
// yomiP	yomigana
Boolean Kanji2Yomigana(CharPtr yomiP, CharPtr kanjiP, GlobalPtr g)
{
  CharPtr tmpKanjiP;
  Int kanjiLen;
  Long kanjiPos, yomiPos, i;

  //  WinDrawChars(g->kanaP, 8, 100, 0);
  //  WinDrawChars(kanjiP, MyStrLen(kanjiP), 0, 10);

  kanjiLen = MyStrLen(kanjiP);
  
  tmpKanjiP = MemPtrNew(MyStrLen(kanjiP) + 2);

  *tmpKanjiP = '/';
  *(tmpKanjiP + 1) = nullChr;
  
  MyStrCat(tmpKanjiP, kanjiP);

  if(ManaeGetCandRec(g)) {  
    for (kanjiPos = 0;
	 (i = BM1(tmpKanjiP, (kanjiLen + 1),
		  (unsigned char*)g->candP + kanjiPos,
		  (unsigned long)(g->candRecLen - kanjiPos))) != -1;
	 kanjiPos = kanjiPos + i + 1) {
      if ((*(g->candP + kanjiPos + kanjiLen + 1) == '/') ||
	  (*(g->candP + kanjiPos + kanjiLen + 1) == crChr)) break;
    }
    
    //    WinDrawChars((g->candP + kanjiPos), kanjiLen + 1, 0, 0 );
    if (kanjiPos == -1) {
      // not found.
      *yomiP = nullChr;
      ManaeReleaseCandRec(g);
      return(false);
    }

    // search line header
    for (yomiPos = kanjiPos;
	 ((*(g->candP + yomiPos) != crChr) && (yomiPos > 0))
	   ; yomiPos--) {
    }

    yomiPos = yomiPos + ((yomiPos == 0) ? 0 : 1);
    // () are important. '?' is stronger than '+'!!! 

    //copy a yomigana.
    *yomiP = *g->kanaP;
    *(yomiP + 1)= *(g->kanaP + 1);

    for (i = 0;
	 (*(g->candP + yomiPos + i) != '/') && (i < (KANALEN - 2 - 1)); i++) {
      *(yomiP + 2 + i) = *(g->candP + yomiPos + i);
    }

    *(yomiP + 2 + i) = nullChr;

    ManaeReleaseCandRec(g);
    //    WinDrawChars(yomiP, MyStrLen(yomiP), 0, 20);
    return(true);
  }
  *yomiP = nullChr;
  return(false);
}
#endif
