/* 
   manae --- skimple kana MANA Exchanger
   manae.c --- a main module
   Copyright 1998-2002 IWAMA Naozumi
   This file is written in SJIS.
   ̃t@C SJIS ŋLqĂ܂B
*/

#ifndef _MANAE_C_
#define _MANAE_C_

#include <PalmOS.h>

#include "id.h"
#include "manae.h"
#include "myfunc.h"

// prototypes

// for kanji.c
Boolean ManaeKanjiHandleEvent(FieldPtr fld, EventPtr event, GlobalPtr g);
Boolean ManaeCheckStartKanji(EventPtr event, GlobalPtr g);
Boolean ManaeDrawChars(CharPtr str, UInt len, Short x, Short y, GlobalPtr g);
Boolean isKakutei(Char c, GlobalPtr g);

// for kanjidb.c
VoidHand ManaeGetLearnCandRec(GlobalPtr g);
Err ManaeReleaseLearnCandRec(GlobalPtr g);
Err ManaeReleaseCandRec(GlobalPtr g);
Err ManaeReleaseOnlyLearnCandRec(GlobalPtr g);
Err ManaeReleaseOnlyCandRec(GlobalPtr g);

// cands.c
Boolean CandsFormHandleEvent (EventPtr event);
Boolean CandsFormEventLoop();
Boolean CandsSetButton(Char candsButtonStr[CANDSPERPAGE][CANDSBUTTONSTRLEN], Int page, CharPtr candsP);
ULong LearnWriteVersion(GlobalPtr g);

// manaemori.c
Boolean CheckManaemori(GlobalPtr g);

// gui.c
Boolean ShowCurrMode(Byte guiMode, GlobalPtr g);

// prefsRec.c
Boolean PreferencesSave(VoidPtr prefsP);
Boolean PreferencesLoad(VoidPtr prefsP);
Byte PreferencesGetMode(DWord ftrVal);
DWord PreferencesSetMode(Char mode, DWordPtr ftrValP);
Byte PreferencesGetKanjiMode(DWord ftrVal);
DWord PreferencesSetKanjiMode(Char mode, DWordPtr ftrValP);
Boolean PreferencesGetNonSkkMode(DWord ftrVal);
DWord PreferencesSetNonSkkMode(Boolean nonSkk, DWordPtr ftrValP);
Boolean PreferencesGetThumbTypeMode(DWord ftrVal);
DWord PreferencesSetThumbTypeMode(Boolean thumbType, DWordPtr ftrValP);

// showmode.c
Boolean CheckShowMode(GlobalPtr g);

// completion2.c
Boolean DComplEnd(GlobalPtr g);

// init.c
GlobalPtr ManaeStart(void);
Err ManaeStop(GlobalPtr g);
Err ManaeLoadPreferences(GlobalPtr g);

inline static void DP(const CharPtr s)
{
#ifdef DEBUG
  WinDrawChars(s, StrLen(s), 0, 0);
#endif
  return;
}


// general purpose functions 

void InsertToMainField2(CharPtr out, GlobalPtr g)
{
  LocalID id;
  VoidPtr v;
  FormPtr frm;
  FieldPtr fld;
  FormObjectKind kind;
  Short x, y;
  Int consonantLen;
  RectangleType r;

  frm = FrmGetActiveForm();
  id = FrmGetFocus(frm);
  v = FrmGetObjectPtr(frm, id);
  kind = FrmGetObjectType(frm, id);
  fld = (kind == frmFieldObj ? v :
	   kind == frmTableObj ? TblGetCurrentField(v) :
	   NULL);
  if (fld != g->fld) {
    FrmCustomAlert(Alert, "manae", "InsertToMainField2", "panic");
    return;
  }
  if (fld) {
    if (g->event->data.keyDown.chr == backspaceChr) {
      MyInsPtGetLocation(&x, &y);
      WinDisplayToWindowPt(&x, &y);
      r.topLeft.x = x;
      r.topLeft.y = y;
      r.extent.x = FntCharsWidth("", 2);
      r.extent.y = FntCharHeight();
      WinEraseRectangle (&r, 0);
    }

    // For quick resoponse, draw "out" before FldInsert() 
    // It's a deception.
    MyInsPtGetLocation(&x, &y);
    WinDisplayToWindowPt(&x, &y);
    consonantLen = MyStrLen(out); // temporary out length into consonantLen
    /*
    if ((fld->rect.topLeft.x + fld->rect.extent.x) > 
	(x + FntCharsWidth("", 2) * consonantLen / 2)) {
      WinDrawChars(out, consonantLen, x + 1, y);
    }
    */
    FldInsert(fld, out, StrLen(out));
    MyInsPtGetLocation(&x, &y);
    WinDisplayToWindowPt(&x, &y);
    consonantLen = StrLen(&g->consonant);
    /*
    if ((fld->rect.topLeft.x + fld->rect.extent.x) > (x + 5 * consonantLen)) {
      WinDrawChars(&g->consonant, consonantLen, x + 2, y);

    }
    */
  }
}

// RETURNED:
//   do nothing: false
Boolean AddLineBuffer(CharPtr out, GlobalPtr g)
{
  Short x, y;
  Char printStr[KANALEN * 2];
  Int bufferLen, consonantLen, printLen;
  SWord charsWidth;
  Short charHeight, charWidth;

  if (out[0] != nullChr) {
    //    MyDmStrCat(g->lineBufferP, out);
    StrCat(g->lineBufferP, out);
  }

  MyInsPtGetLocation(&x, &y);
  WinDisplayToWindowPt(&x, &y);
  charHeight = FntCharHeight();
  charWidth = FntCharsWidth("", 2);

  if (*(g->formerDrawP) != nullChr) {
    // Erase Printed
    RectangleType r;

    r.topLeft.x = x;
    r.topLeft.y = y;
    r.extent.x = (StrLen(g->formerDrawP) + 1) * charWidth / 2;
    r.extent.y = charHeight;
    InsPtEnable(false);
    WinEraseRectangle (&r, 0);
    InsPtEnable(true);
  }
  
  if ((g->flush == true) ||
      ((*out != nullChr) && (g->autoInsertion == true))) {
    if (*(g->lineBufferP) == nullChr) return(false);

    WinDrawGrayLine(x + 1, y - 1 + charHeight, 
		    g->fld->rect.topLeft.x + g->fld->rect.extent.x - 1,
		    y - 1 + charHeight);

    InsertToMainField2(g->lineBufferP, g);
    *(g->formerDrawP) = nullChr;
    *(g->lineBufferP) = nullChr;
    return(true);
  }

  bufferLen = StrLen(g->lineBufferP);
  consonantLen = StrLen(&g->consonant);
  charsWidth = (charWidth * (bufferLen) / 2) + 7 * consonantLen;

  if ((g->fld->rect.topLeft.x + g->fld->rect.extent.x) > 
      (x + charsWidth)) {
    StrCopy(printStr, g->lineBufferP); // This is slow,
    StrCat(printStr, &g->consonant);  // but easy to understand....
    printLen = StrLen(printStr);      // I know the method which doesn't copy.
    WinDrawChars(printStr, printLen, x + 1, y);

    WinDrawLine(x + 1, y - 1 + charHeight, 
		    x + 1 + charsWidth, y - 1 + charHeight);

    mystrncpy(g->formerDrawP, printStr, StrLen(printStr) + 1);
  } else { // erase line and insert line buffer.

    WinDrawGrayLine(x + 1, y - 1 + charHeight, 
		    g->fld->rect.topLeft.x + g->fld->rect.extent.x - 1,
		    y - 1 + charHeight);

    InsertToMainField2(g->lineBufferP, g);
    *(g->formerDrawP) = nullChr;
    *(g->lineBufferP) = nullChr;
    //    DmSet(g->lineBufferP, 0, 10, 0);
  }
  return(true);
}

static Int LineBufferLen(GlobalPtr g)
{
  return(StrLen(g->lineBufferP));
}

static Boolean Lock2(GlobalPtr g)
{
  if (g->locked) return false;
  g->locked = true;
  return true;
}

static void Unlock2(GlobalPtr g)
{
  g->locked = false;
}

// kanae functions.

static Boolean KanaeChangeModeTap(CharPtr out, Char c, GlobalPtr g)
{
  Boolean ret;
  //  SWord dispX, dispY;

  if (g->thumbTypeMode) { 
    return(false);
  }

  if (c != '.') return(false);
  
  if (GetGraffitiRegion(g->event->screenX, g->event->screenY,
			g->encoding, g->romVersion) !=
      0) {
    return(false);
  }
  
  switch(g->mode) {
  case ALPHA:
    g->mode = HIRA;
    out[0] = nullChr;
    ret = true;
    break;
  case HIRA:
    g->mode = KATA;
    out[0] = nullChr;
    ret = true;
    break;
  case KATA:
    g->mode = ALPHA;
    out[0] = nullChr;
    ret = true;
    break;
  default:
    ret = false;
    break;
  }
  return(ret);
}  

// kanae change mode
static Boolean KanaeChangeMode(CharPtr out, Char c, GlobalPtr g)
{
  if (KanaeChangeModeTap(out, c, g)) {
    return(true);
  }

  switch(g->mode) {
  case ALPHA:
    out[0] = nullChr;
    if (c == g->alpha2HiraC) {
      g->mode = HIRA;
      return(true);
    }
    break;

  case ZEN:
    out[0] = nullChr;
    if (c == g->zen2HiraC) {
      g->mode = HIRA;
      return(true);
    }
    break;

  case HIRA:
    out[0] = nullChr;
    if (c == g->hira2KataC) {
      g->mode = KATA;
      return(true);
    }
    if (c == g->hira2ZenC) {
      g->mode = ZEN;
      return(true);
    }
    if (c == g->hira2AlphaC) {
      g->mode = ALPHA;
      return(true);
    }
    break;

  case KATA:
    out[0] = nullChr;
    if (c == g->kata2HiraC) {
      g->mode = HIRA;
      return(true);
    }
    if (c == g->kata2ZenC) {
      g->mode = ZEN;
      return(true);
    }
    if (c == g->kata2AlphaC) {
      g->mode = ALPHA;
      return(true);
    }
    break;

  default:
    g->mode = ALPHA;
    return(false);
    break;
  }
  return(false);
}

// check the validity of the consonant
static Boolean KanaeValidConsonant(CharPtr s, GlobalPtr g)
{
  Int i, len;

  len = StrLen(s);

  switch (len) {

  case 0:
    return(true);
    break;

  case 1:
    if (s[0] == 'n') {
      return(true);
    }
    if (s[0] == s[1]) {
      return(true);
    }
    for (i = 0; ((CharPtr)g->seionP)[i] != nullChr; i += 42) {
      if (((CharPtr)g->seionP)[i] == s[0]) {
	return(true);
      }
    }
    for (i = 0; ((CharPtr)g->dakuonP)[i] != nullChr; i += 42) {
      if (((CharPtr)g->dakuonP)[i] == s[0]) {
	return(true);
      }
    }
    return(false);
    break;
    
  case 2:
    for (i = 0; ((CharPtr)g->youon1P)[i] != nullChr; i += 42) {
      if (((((CharPtr)g->youon1P)[i] == s[0])) &&
	  (((CharPtr)g->youon1P)[i + 1] == s[1])) {
	return(true);
      }
    }
    for (i = 0; ((CharPtr)g->youon2P)[i] != nullChr; i += 42) {
      if (((((CharPtr)g->youon2P)[i] == s[0])) &&
	  (((CharPtr)g->youon2P)[i + 1] == s[1])) {
	return(true);
      }
    }
    return(false);
    break;

  default:
    return(false);
    break;
  }
  return(false);
}

Boolean KanaeConvertConsonant(CharPtr out, Char c, GlobalPtr g)
{
  Char tmpC[10];
  Int len;

  StrCopy(tmpC, &g->consonant);
  len = StrLen(tmpC);

  // switch consonant length
  switch (len) {
  case 0:
    if (! (isconsonant(c))) {
      return(false);
    }
    tmpC[0] = c;
    tmpC[1] = nullChr;
    StrCopy(&g->consonant, tmpC);
    return(true);
    break;

  case 1:
    if (tmpC[0] == 'n') {
      if (!isconsonant(c) || (c == 'n')) {
	StrCopy(out, (g->mode == HIRA) ? "" : "");
	g->consonant = nullChr;
	g->consonant1 = nullChr;
	g->consonant2 = nullChr;
	g->consonant3 = nullChr;
	return(true);
      } 
      if (c != 'y') {
	StrCopy(out, (g->mode == HIRA) ? "" : "");

	g->consonant = c;
	g->consonant1 = nullChr;
	return(true);
      }
    }

    if (tmpC[0] == c) {
      StrCopy(out, (g->mode == HIRA) ? "" : "b");
      return(true);
    }

    addChar(tmpC, c);
    if (KanaeValidConsonant(tmpC, g)) {
      StrCopy(&g->consonant, tmpC);
      return(true);
    } else {
	StrCopy(&g->consonant, &tmpC[1]);
      return(true);
    }
    break;
    
  case 2:
    addChar(tmpC, c);
    if (KanaeValidConsonant(&tmpC[1], g)) {
      StrCopy(&g->consonant, &tmpC[1]);
      return(true);
    } else {
      if (KanaeValidConsonant(&tmpC[2], g)) {
	StrCopy(&g->consonant, &tmpC[2]);
	return(true);
      } else {
	g->consonant = nullChr;
	g->consonant1 = nullChr;
	g->consonant2 = nullChr;
	g->consonant3 = nullChr;
	return(false);
      }
    }
    break;
    
  default:
    g->consonant = nullChr;
    g->consonant1 = nullChr;
    g->consonant2 = nullChr;
    g->consonant3 = nullChr;
    return(false);
    break;
  }
  return(false);
}

static Boolean KanaeConvertKana(CharPtr out, CharPtr input, Int vowelVector, CharPtr table, Int consonantLen, GlobalPtr g)
{
  Int i;
  Char tmpC[4];
  
  tmpC[0] = input[0];
  tmpC[1] = (consonantLen == 1) ? ' ' : input[1];
  tmpC[2] = nullChr;

  for (i = 0; table[i] != nullChr; i += 42) {
    if ((table[i] == tmpC[0]) && (table[i + 1] == tmpC[1])) {

/* This doesn't work under Palm OS 1.0
   StrNCopy(out,
	       &table[i + 2 + ((g->mode == HIRA) ? 0 : 20) +
		      4 * vowelVector], 4);
*/
      mystrncpy(out,
	       &table[i + 2 + ((g->mode == HIRA) ? 0 : 20) +
		      4 * vowelVector], 4);
      out[4] = nullChr;
      space2Null(out);
      return(true);
    }
  }
  return(false);
}

static Boolean KanaeConvertVowel(CharPtr out, Char c, GlobalPtr g)
{
  // c must be vowel!

  Char tmpC[10];
  Int len, vowelVector;

  StrCopy(tmpC, &g->consonant);
  len = StrLen(tmpC);
  out[0] = nullChr;

  g->consonant = nullChr;
  g->consonant1 = nullChr;
  g->consonant2 = nullChr;
  g->consonant3 = nullChr;
  if ((vowelVector = vowelNum(c)) == 5) {
    return(false);
  }

  switch (len) {

  case 0:
 /* This doesn't work under Palm OS 1.0
    StrNCopy(out,
	     &((CharPtr)g->seionP)[2 + ((g->mode == HIRA) ? 0 : 20) +
				    4 * vowelVector], 4);
*/
    mystrncpy(out,
	     &((CharPtr)g->seionP)[2 + ((g->mode == HIRA) ? 0 : 20) +
				    4 * vowelVector], 4);
    space2Null(out);
    return(true);
    break;

  case 1:
    if (KanaeConvertKana(out, tmpC, vowelVector, g->seionP, 1, g)) return(true);
    return(KanaeConvertKana(out, tmpC, vowelVector, g->dakuonP, 1, g));
    break; // This is non sense...

  case 2:
    if (KanaeConvertKana(out, tmpC, vowelVector, g->youon1P, 2, g)) return(true);
    return(KanaeConvertKana(out, tmpC, vowelVector, g->youon2P, 2, g));
    break; // This is non sense...
  default:
    FrmCustomAlert(Alert, "Kanae", "KanaeConvertVowel", "");
    g->consonant = nullChr;
    g->consonant1 = nullChr;
    g->consonant2 = nullChr;
    g->consonant3 = nullChr;
    
    return(false);
    break;
  }
  return(false);
}

static Boolean KanaeConvertKigou(CharPtr out, Char c, CharPtr table, GlobalPtr g)
{
  Int i;
  
  for(i = 0; table[i] != nullChr; i += 3) {
    if (c == table[i]) {
      out[0] = table[i + 1];
      out[1] = table[i + 2];
      out[2] = nullChr;
      return(true);
    }
  }
  return(false);
}

Boolean KanaeConvert(CharPtr out, Char c, GlobalPtr g)
{
  Boolean ret;
  SWord dispX, dispY;

  out[0] = nullChr;

  // check event type
  if (g->event->eType != keyDownEvent) {
    g->flush = true;
    AddLineBuffer(out, g);
    return(false);
  }

  g->flush = true;

  if (KanaeChangeMode(out, c, g)) {
    return(true);
  }

  if (g->mode == ALPHA) {
    return(false);
    out[0] = c;
    out[1] = nullChr;
    return(true);
  }

  if (g->mode == ZEN) {
    // alpha-numeric
    if ((c >= '0') && (c <= '9')) {
      out[0] = 0x82;
      out[1] = 0x4f + c - '0';
      out[2] = nullChr;
      return(true);
    }
    if ((c >= 'A') && (c <= 'Z')) {
      out[0] = 0x82;
      out[1] = 0x60 + c - 'A';
      out[2] = nullChr;
      return(true);
    }
    if ((c >= 'a') && (c <= 'z')) {
      out[0] = 0x82;
      out[1] = 0x81 + c - 'a';
      out[2] = nullChr;
      return(true);
    }

    if (KanaeConvertKigou(out, c, g->kigouP, g)) {
      return(true);
    }

    out[0] = nullChr; // don't convert a char and 
    return(false); // call old trap.
  }

  // kana mode

  // check the pen down area.
  // Number area: not convert.
  dispX = g->event->screenX;
  dispY = g->event->screenY;
  WinWindowToDisplayPt(&dispX, &dispY);

  if (!g->thumbTypeMode) {
    if (
	(!(((c >= 'a') && (c <= 'z')) || ((c >= 'A') && (c <= 'Z')))) &&
	(dispX >= 90) && (dispX <= 130) && 
	(dispY >= 170) && (dispY <= 215)) {
      return(false);
    }
  }

  /*
  if (KanaeConvertKigou(out, c, g->kanakigouP, g)) {
    return(true);
  }
  */

  //  to lower
  if ((c >= 'A') && (c <= 'Z')) {
    c = c - 'A' + 'a';
  }

  if (isvowel(c)) {
    KanaeConvertVowel(out, c, g);
    g->flush = false;
    return(true);
  }

  // c is consonant or other 
  if (! (isconsonant(c))) {
    // c is NOT consonant or vowel.
    g->flush = true;
    if (c == backspaceChr) {
      if (g->consonant != 0) {
	g->consonant = nullChr;
	g->consonant1 = nullChr;
	g->consonant2 = nullChr;
	g->consonant3 = nullChr;
    	return(true); // only flush buffer
      }
      return(false);
    }

    if ((g->consonant == 'n') &&
	(g->consonant1 == nullChr)) {

      KanaeConvertConsonant(out, 'n', g);
      g->consonant = nullChr;
      g->consonant1 = nullChr;
      g->consonant2 = nullChr;
      g->consonant3 = nullChr;
      KanaeConvertKigou((out + 2), c, g->kanakigouP, g);
      return(true);
    }


    g->consonant = nullChr;
    g->consonant1 = nullChr;
    g->consonant2 = nullChr;
    g->consonant3 = nullChr;

    if (KanaeConvertKigou(out, c, g->kanakigouP, g)) {
      return(true);
    }
    return(false);
  }

  // c is consonant
  ret = KanaeConvertConsonant(out, c, g);

  g->flush = false;
  return(ret);
}

// manae functions.

static Word EmacsKeyTrans(Word c)
{
  Word transC;
  //  WinDrawChars("*", 1, 0, 0);
  switch (c) {
  case ('f' - 'a' + 1):
  case 0x0109:
    transC = rightArrowChr;
    break;
  case ('b' - 'a' + 1):
  case 0x0101:
    transC = leftArrowChr;
    break;
  case ('p' - 'a' + 1):
    transC = upArrowChr;
    break;
  case ('n' - 'a' + 1):
  case 0x0103:
    transC = downArrowChr;
    break;
/* don't work...sigh...
  case ('s' - 'a' + 1):
    transC = findChr;
    break;
  case ('w' - 'a' + 1):
    transC = cutChr;
    break;
  case ('y' - 'a' + 1):
    transC = pasteChr;
    break;
*/
  default:
    transC = c;
    break;
  }
  /*
  if (c == transC) {
    WinDrawChars("f", 1, 0, 0);
  } else {
    WinDrawChars("t", 1, 0, 0);
  }
  */
  return(transC);
}

Boolean isupper(Char c)
{
  if ((c >= 'A') && (c <= 'Z')) {
    return(true);
  } else {
    return(false);
  }
}

Boolean islower(Char c)
{
  if ((c >= 'a') && (c <= 'z')) {
    return(true);
  } else {
    return(false);
  }
}

Boolean ManaeSetKanaMode(GlobalPtr g)
{
  g->mode = HIRA; // alpha, hira, kata, kigou
  g->kanjiMode  = NONKANJI;
  g->consonant = nullChr;
  g->consonant1 = nullChr;
  g->consonant2 = nullChr;
  g->consonant3 = nullChr;

  //  if (DmSet(g->kanaP, 0, 4, 0))  // initialize kana buffer
  //      ErrFatalDisplayIf(true, "Cannot initalize kana buffer");
  //  if (DmSet(g->okuriP, 0, 4, 0))  // initialize consonant buffer
  //      ErrFatalDisplayIf(true, "Cannot initalize okuri buffer");
  *(g->kanaP) = nullChr;
  *(g->okuriP) = nullChr;
  return(true);
}

Boolean ManaeSetMode(Char c, GlobalPtr g)
{
  switch (g->mode) {
  case HIRA:
    if (c == g->hira2KataC) {
      g->mode = KATA;
    }
    if (c == g->hira2ZenC) {
      g->mode = ZEN;
    }
    if (c == g->hira2AlphaC) {
      g->mode = ALPHA;
    }

    break;

  case KATA:
    if (c == g->kata2HiraC) {
      g->mode = HIRA;
    }
    if (c == g->kata2ZenC) {
      g->mode = ZEN;
    }
    if (c == g->kata2AlphaC) {
      g->mode = ALPHA;
    }
    break;

  default:
    g->mode =HIRA; // alpha, hira, kata, kigou
    break;
  }

  g->kanjiMode = NONKANJI;
  g->consonant = nullChr;
  g->consonant1 = nullChr;
  g->consonant2 = nullChr;
  g->consonant3 = nullChr;

  //  if (DmSet(g->kanaP, 0, 4, 0))  // initialize kana buffer
  //      ErrFatalDisplayIf(true, "Cannot initalize kana buffer");
  //  if (DmSet(g->okuriP, 0, 4, 0))  // initialize consonant buffer
  //      ErrFatalDisplayIf(true, "Cannot initalize okuri buffer");
  *(g->kanaP) = nullChr;
  *(g->okuriP) = nullChr;

  return(true);
}

// Manae Main Function
// #define DEBUG
// Manae Main Function
unsigned char Manae(void *fldA, void *eventA)
{
  Boolean (*oldtrap)(FieldPtr, EventPtr);
  //  FormPtr frm;
  FieldPtr fld;
  Char out[KANALEN];
  EventPtr event;
  int ret;
  GlobalPtr g;
  DWord ftrvalue;
  Boolean handled, callOldtrap;
  FontID font;

  //  DmOpenRef db;
  fld = (FieldPtr) fldA;
  event = (EventPtr) eventA;
  ret = true;

  if (event->eType == keyDownEvent) {

#ifdef DEBUG
    ErrorPrintHex((ULong)event->data.keyDown.chr, 80, 10);
#endif

    // for HandEra
    if ((event->data.keyDown.chr >= vchrCFlashMin) && 
	(event->data.keyDown.chr <= vchrCFlashMax)) {
      return(false);
    }
  }

  if (FtrGet(CREATOR, FEATUREGLOBAL, (DWordPtr)&g) != 0) {
    // no such feature
    if ((g = ManaeStart()) == NULL) {
      FtrGet(CREATOR, 1000, &ftrvalue);
      oldtrap = (Boolean (*)(FieldPtr, EventPtr))ftrvalue;
      return((*oldtrap)(fld, event));
    }
  } else {
    if (g->fld != fld) {
      // The field has been changed.

      UInt cardNo;
      LocalID currAppDbID;

      if (SysCurAppDatabase(&cardNo, &currAppDbID) == 0) { // Get curr dbID
	if (g->currAppDbID != currAppDbID) {
	  // A current application has been changed.
	  //	  ErrDisplay("The app has been changed.");
	  g->currAppDbID = currAppDbID;

	  if (g->dcP != NULL) {
	    // Turn off dynamic completion mode, if it is active.
	    if (ManaeReleaseLearnCandRec(g) != 0) {
	      ErrorPrint("can't release learn cand rec", 0, 0);
	    }
	    // I assume chunks have been free.
	    g->dcP = NULL;
	  }

	  ManaeStop(g);
	  if ((g = ManaeStart()) == NULL) {
	    ErrorPrint("g = NULL", 0, 0);
	    FtrGet(CREATOR, 1000, &ftrvalue);
	    oldtrap = (Boolean (*)(FieldPtr, EventPtr))ftrvalue;
	    return((*oldtrap)(fld, event));
	  }
	}
      }
    }
  }
  
  if(! Lock2(g)){
    FtrGet(CREATOR,1000, &ftrvalue);
    oldtrap = (Boolean (*)(FieldPtr, EventPtr))ftrvalue;
    return((*oldtrap)(fld, event));
  }

  g->fld = fld;
  g->event = event;
  g->handled = true;

  if (g->event->eType == keyDownEvent) {
    g->event->data.keyDown.chr = EmacsKeyTrans(g->event->data.keyDown.chr);
  }

  callOldtrap = false;

  // Initialize the font.
  font = FntGetFont();
  FntSetFont(font);

  switch (g->kanjiMode) {
  case NONKANJI:
    DP("NONKANJI");
    if (g->realChr != nullChr) {
      g->event->data.keyDown.chr = g->realChr;
    }
    if (ManaeCheckStartKanji(g->event, g)) {
      ret = true;
      break;
    }
    if (event->eType == keyDownEvent) {
      // Initialize the font.

      // for shortcut
      if (g->event->data.keyDown.chr == chrShortcutStroke) {
	g->event->data.keyDown.chr = '$';
	g->mode = ALPHA;
	callOldtrap = true;
	break;
      }

      if (isKakutei(g->event->data.keyDown.chr, g) &&
	  (LineBufferLen(g) != 0)) {
	g->flush = true;
	AddLineBuffer("", g);
	break;
      }
      if (KanaeConvert(out, g->event->data.keyDown.chr, g)) {
	// kana or other convertable char
	AddLineBuffer(out, g); // add
	ret = true;
	break;
      }
    }
    // can't convert char or not keyDown Event
    callOldtrap = true;
    out[0] = nullChr;
    AddLineBuffer(out, g); // flush buffer

    break;

  case KANJIIN:
    DP("KANJIIN");
  case OKURIIN:
    DP("KANJIOKURIIN");
  case HENKAN:
    DP("HENKAN");
  case KANJI:
    DP("KANJI");
    // Kanji Mode
    if (g->realChr != nullChr) {
      event->data.keyDown.chr = g->realChr;
      g->realChr = nullChr;
    }
    if (ManaeKanjiHandleEvent(fld, event, g)) {
      ret = true;
      // pop up a Candidates' form.
      if (g->candsFrmFlg == true) {
	FormPtr candsFrm;
	DmOpenRef db;
	db = DmOpenDatabaseByTypeCreator(MANAEAPPTYPE, CREATOR,
					 dmModeReadOnly);
	ErrFatalDisplayIf(db == NULL,"Cannot open manae resources");

	candsFrm = FrmInitForm(ID_CANDSFORM);
	FtrSet(CREATOR, FEATURECANDSFRM, (DWord)candsFrm);
	ErrFatalDisplayIf(candsFrm == NULL,"Can't init Form");
	FrmSetEventHandler(candsFrm, CandsFormHandleEvent);
	FrmSetActiveForm(candsFrm);
	//	FrmDrawForm(candsFrm);
	// added
	CandsFormEventLoop(candsFrm);
	FrmReturnToForm(NULL);
	DmCloseDatabase(db);
	g->candsFrmFlg = false;
      }
    } else {
      // call old trap 
      callOldtrap = true;
    }
    break;

  default:
    // not run here.
  }
  CheckShowMode(g);
  handled = g->handled;
  //  ManaeUnlockReleaseResource(g);
  //  ManaeCloseMyself(g);

  if (callOldtrap) {
    //    DP("oldtrap");

    FtrGet(CREATOR,1000,&ftrvalue);
    oldtrap = (Boolean (*)(FieldPtr, EventPtr))ftrvalue;
    ret = (*oldtrap)(fld, g->event);
  }

  Unlock2(g);
  if (! handled) {
    return(Manae(fldA, eventA));
  }
  //  event->data.keyDown.chr = nullChr;
  return(ret);
}
// #undef DEBUG
#endif
